{$O+,F+,N-}
Unit Maus; (* Routinen fr die Maus; by Claude Schmidhuber, 1994/95 *)
(*
You can use an exported mouse-cursor by calling
SetGCursorMask(einCursor,ClickX,ClickY);
or
play with some predefined cursors like
SetGCursorMask(GrCursorMasken[1],GrCursorClicks[1].ClickX,GrCursorClicks[1].ClickY);

Don't forget to switch to a graphicmode and to call InitMaus first.

Have Fun !

12.6.98 Claude.
*)


Interface

 Uses Dos;

 Type TGrCursorMask= Array[0..31] of Word; (* Nur fr Grafikmodus, Bild+Maske *)
      TClick=  Record
                 ClickX,
                 ClickY: Integer
               End;

 Var Maus3Tasten: Boolean;

 Const GrCursorMasken: Array[1..9] of TGrCursorMask =
      (($F3FF,$E1FF,$E1FF,$E1FF,$E1FF,$E049,$E000,$8000, (* Hand *)
        $0000,$0000,$07FC,$07F8,$9FF9,$8FF1,$C003,$E007,
        $0C00,$1200,$1200,$1200,$1200,$13B6,$1249,$7249,
        $9249,$9001,$9001,$8001,$4002,$4002,$2004,$1FF8),

       ($0000,$0000,$0000,$8001,$c003,$e007,$f00f,$e007, (* Sanduhr *)
        $c003,$8001,$0000,$0000,$0000,$0000,$0000,$0000,
        $0000,$7ffe,$6006,$300c,$1818,$0c30,$0660,$03c0,
        $0660,$0c30,$1998,$33cc,$67e6,$7ffe,$0000,$0000),

       ($3fff,$1fff,$0fff,$07ff,$03ff,$01ff,$00ff,$007f, (* Pfeil *)
        $003f,$001f,$01ff,$10ff,$30ff,$f87f,$f87f,$fc3f,
        $0000,$4000,$6000,$7000,$7800,$7c00,$7e00,$7f00,
        $7f80,$7fc0,$7c00,$4600,$0600,$0300,$0300,$0180),

       ($8003,$0001,$0001,$1831,$1011,$0001,$0001,$8003, (* Hammer *)
        $F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F,
        $0000,$3FF8,$4284,$4104,$4284,$4444,$3FF8,$0380,
        $0380,$0380,$0380,$0380,$0380,$0380,$0380,$0000),

       ($FFF0,$FFE0,$FFC0,$FF81,$FF03,$0607,$000F,$001F, (* Haken *)
        $803F,$C07F,$E0FF,$F1FF,$FFFF,$FFFF,$FFFF,$FFFF,
        $0000,$0006,$000C,$0018,$0030,$0060,$70C0,$3980,
        $1F00,$0E00,$0400,$0000,$0000,$0000,$0000,$0000),

       ($F01F,$E00F,$C007,$8003,$0441,$0C61,$0381,$0381, (* Fadenkreuz *)
        $0381,$0C61,$0441,$8003,$C007,$E00F,$F01F,$FFFF,
        $0000,$07C0,$0920,$1110,$2108,$4004,$4004,$783C,
        $4004,$4004,$2108,$1110,$0920,$07C0,$0000,$0000),

       ($C003,$8001,$07E0,$0000,$0000,$0000,$0000,$0000, (* Grinskopf *)
        $0000,$0000,$0000,$8001,$C003,$C003,$E007,$F81F,
        $0FF0,$1008,$2004,$4002,$4E72,$4A52,$4E72,$4002,
        $4992,$581A,$2424,$13C8,$1008,$0C30,$03C0,$0000),

       ($1FF8,$0FF0,$07E0,$03C0,$8181,$C003,$E007,$F00F, (* ein X *)
        $F81F,$F00F,$E007,$C003,$8181,$03C0,$07E0,$0FF0,
        $8001,$C003,$6006,$300C,$1818,$0C30,$0660,$03C0,
        $0180,$03C0,$0660,$0C30,$1818,$300C,$6006,$C003),

       ($F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F, (* Schwert *)
        $8003,$8003,$8003,$8003,$8003,$F83F,$F01F,$F01F,
        $0100,$0380,$0380,$0380,$0380,$0380,$0380,$0380,
        $0380,$3398,$3398,$3FF8,$0380,$0380,$0380,$07C0));

       GrCursorClicks: Array[1..9] of TClick =
                      ((ClickX: $08; ClickY: $00),  (* Hand *)
                       (ClickX: $0E; ClickY: $08),  (* Sanduhr *)
                       (ClickX: $01; ClickY: $01),  (* Pfeil *)
                       (ClickX: $0E; ClickY: $03),  (* Hammer *)
                       (ClickX: $0D; ClickY: $0B),  (* Haken *)
                       (ClickX: $0E; ClickY: $07),  (* Fadenkreuz *)
                       (ClickX: $0E; ClickY: $05),  (* Grinskopf *)
                       (ClickX: $0E; ClickY: $08),  (* ein X *)
                       (ClickX: $0E; ClickY: $00)); (* Schwert *)

 Function InitMaus: Boolean;
 Procedure ZeigeMaus(Sichtbar:Boolean);
 Function Maustaste: Byte;
 Function MausX: Integer;
 Function MausY: Integer;
 Procedure MausXYT(X,Y: Word; Taste: Byte);  (* liefert X,Y,Taste zurck *)
 Function MausStatus_l(X,Y: Word; Taste: Byte): Boolean;
 (* ^ Status Maus loslassen *)
 Function MausinBox(X1,Y1,X2,Y2: Integer): Boolean;
 Procedure SetGCursorMask(Var CursorMask: TGrCursorMask; ClickX,ClickY: Byte);
 Procedure SetzeMaus(X,Y: Word);
 Procedure SetzeMausFenster(X1,Y1,X2,Y2: Word);
 Procedure SetzeMausRate(Horiz,Vert: Word); (* Mausgeschwindingkeit *)
 Procedure ZeigeMausKonfig;

 (* Mode13h: MausX = reeles X*2, MausY = reeles Y *)
 (* TextModus: MausX/Y = reeles X/Y *8 *)

Implementation

Var Regs: Registers;

Function InitMaus: Boolean;
Begin
  Regs.AX:=0;
  Regs.BX:=0;
  Intr($33,Regs);
  InitMaus:=(Regs.AX <> 0);
  Maus3Tasten:=(Regs.BX= 3);
End;

Procedure ZeigeMaus(Sichtbar:Boolean);
Begin
  If Sichtbar Then Regs.AX:= 1 Else Regs.AX:= 2;
  Intr($33,Regs);
End;

Function Maustaste: Byte;
Begin
  Regs.AX:= 3;
  Intr($33,Regs);
  Maustaste:= Regs.BX;
End;

Function MausX: Integer;
Begin
  Regs.AX:= 3;
  Regs.BX:=0;
  Intr($33,Regs);
  MausX:=Regs.CX;
End;

Function MausY: Integer;
Begin
  Regs.AX:= 3;
  Regs.BX:=0;
  Intr($33,Regs);
  MausY:=Regs.DX;
End;

Procedure MausXYT(X,Y: Word; Taste: Byte);
Begin
  Regs.AX:= 3;
  Intr($33,Regs);
  X:= Regs.CX;
  Y:= Regs.DX;
  Taste:= Regs.BX;
End;

Function MausStatus_l(X,Y: Word; Taste: Byte): Boolean;
(* liefert X,Y und ob die Taste gedrckt wurde zurck ( True - Ja) *)
Begin
  Regs.AX:= 6;
  Regs.BX:= Taste;
  Intr($33,Regs);
  MausStatus_l:= (Regs.AX = 1);
  X:= Regs.CX;
  Y:= Regs.DX;
End;

Function MausinBox(X1,Y1,X2,Y2: Integer): Boolean; { X,Y * 8 = Maus-X,Y }
Var _X,_Y: Integer;
Begin
  MausinBox:=False;
  For _X:= X1 to X2 Do
   If (_X=MausX) Then For _Y:= Y1 to Y2 Do
    If (_X=MausX)AND(_Y=MausY) Then MausinBox:=True;
End;

Procedure SetGCursorMask(Var CursorMask: TGrCursorMask; ClickX,ClickY: Byte);
Begin
  Regs.AX:= 9;
  Regs.BX:= ClickX;
  Regs.CX:= ClickY;
  Regs.DX:= Ofs(CursorMask);
  Regs.ES:= Seg(CursorMask);
  Intr($33,Regs);
End;

Procedure SetzeMaus(X,Y: Word);
Begin
  Regs.AX:= 4;
  Regs.CX:= X;
  Regs.DX:= Y;
  Intr($33,Regs);
End;

Procedure SetzeMausFenster(X1,Y1,X2,Y2: Word);
Begin
  Regs.AX:= 7;
  Regs.CX:= X1;
  Regs.DX:= X2;
  Intr($33,Regs);
  Regs.AX:= 8;
  Regs.CX:= Y1;
  Regs.DX:= Y2;
  Intr($33,Regs);
End;

Procedure SetzeMausRate(Horiz,Vert: Word);
Begin
  Regs.AX:= $000F;
  Regs.CX:= Horiz;
  Regs.DX:= Vert;
  Intr($33,Regs);
End;

Procedure ZeigeMausKonfig;
Begin
  Writeln;
  If InitMaus Then
  Begin
    Writeln('Maus initialisiert.');
    Write('Maustyp: ');
    Regs.AX:= $24;
    Intr($33,Regs);
    Case Regs.CH of
         $1: Writeln('Bus-Maus');
         $2: Writeln('Serielle Maus');
         $3: Writeln('Inport-Maus');
         $4: Writeln('PS/2-Maus');
         $5: Writeln('HP-Maus');
        Else Writeln('Undefinierbar');
    End;
    If Maus3Tasten Then Writeln('Es handelt sich um eine 3-Tasten-Maus.')
     Else Writeln('Es handelt sich um eine 2-Tasten-Maus.');
    Writeln('Aktuelle Treiberversion: ',Hi(Regs.BX),'.',Lo(Regs.BX));
    Write('Momentane (Treiber-)Sprache: ');
    Regs.AX:= $23;
    Intr($33,Regs);
    Case Regs.BX of
         0: Writeln('Englisch');
         1: Writeln('Franzsisch');
         2: Writeln('Niederlndisch');
         3: Writeln('Deutsch');
         4: Writeln('Schwedisch');
         5: Writeln('Finnisch');
         6: Writeln('Spanisch');
         7: Writeln('Portugiesisch');
         8: Writeln('Italienisch');
       Else Writeln('Unbekannt');
    End;
  End Else Writeln('Keine Maus gefunden.');
End;


END.

